#
# spec file for package xorg-x11-driver-video-unichrome
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           xorg-x11-driver-video-unichrome
%if 0%{?fedora_version} >= 6
BuildRequires:  libdrm-devel xorg-x11-proto-devel xorg-x11-server-sdk
%if 0%{?fedora_version} < 7
BuildRequires:  pkgconfig
%endif
%endif
%if 0%{?mandriva_version} > 2006
BuildRequires:  libx11_6-devel x11-proto-devel x11-server-devel
%if 0%{?mandriva_version} > 2007
BuildRequires:  libdrm-devel
%else
BuildRequires:  libdrm2-devel
%endif
%endif
%if 0%{?suse_version}
BuildRequires:  Mesa-devel popt xorg-x11-sdk
%if 0%{?suse_version} < 1020
BuildRequires:  Mesa-devel xorg-x11-devel
%if 0%{?suse_version} > 1000
BuildRequires:  libdrm-devel
%endif
%endif
%endif
Url:            unichrome.sf.net
License:        X11/MIT
Group:          System/X11/Servers/XF86_4
%if 0%{?suse_version}
Supplements:    modalias(pci:v00001106d00003122sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00001106d00007205sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00001106d00003108sv*sd*bc*sc*i*)
#Supplements:    modalias(pci:v00001106d00003118sv*sd*bc*sc*i*)
#Supplements:    modalias(pci:v00001106d00003344sv*sd*bc*sc*i*)
#Supplements:    modalias(pci:v00001106d00003157sv*sd*bc*sc*i*)
#Supplements:    modalias(pci:v00001106d00003230sv*sd*bc*sc*i*)
#Supplements:    modalias(pci:v00001106d00003343sv*sd*bc*sc*i*)
#Supplements:    modalias(pci:v00001106d00003371sv*sd*bc*sc*i*)
#Supplements:    modalias(pci:v00001106d00001122sv*sd*bc*sc*i*)
%endif
AutoReqProv:    on
Version:        20091117
Release:        0.3.13
Summary:        The Unichrome Project
PreReq:         coreutils
Requires:       xorg-x11-server
Provides:       xorg-x11-driver-video:%{_libdir}/xorg/modules/drivers/unichrome_drv.so
Source:         xf86-video-unichrome-cd12cce.tar.bz2
Source1:        pci_ids
Patch1:         mandriva2007.diff
Patch2:         libdrm-2.4.20.diff
ExclusiveArch:  %ix86 ia64 ppc ppc64 x86_64
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
The Unichrome Project. The Unichrome Project provides Free and Open
Source support for the S3 Unichrome family of integrated graphics
devices, as found on all recent VIA Technologies Northbridges.



Authors:
--------
    Luc Verhaegen
    The Unichrome Project
    VIA Technologies, Inc.
    S3 Graphics, Inc.

%prep
%setup -n xf86-video-unichrome
%if 0%{?mandriva_version} > 2006
%patch1
%endif
%patch2 -p0

%build
%if 0%{?suse_version} > 1010 || 0%{?fedora_version} >= 6 || 0%{?mandriva_version} > 2006
autoreconf -fi
%configure CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" --without-wrapper
make
%else
xmkmf -a
make CDEBUGFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -I/usr/X11R6/%{_lib}/Server/include -I/usr/X11R6/%{_lib}/Server/include/extensions -I/usr/include/drm" PREPROCESSMANPAGES="true"
%endif

%install
%if 0%{?suse_version} > 1010 || 0%{?fedora_version} >= 6 || 0%{?mandriva_version} > 2006
make install DESTDIR=$RPM_BUILD_ROOT
%if 0%{?suse_version} > 1020 && 0%{?suse_version} < 1100
mkdir -p $RPM_BUILD_ROOT/usr/%{_lib}/xorg/modules/updates/drivers/
mv $RPM_BUILD_ROOT/usr/%{_lib}/xorg/modules/drivers/* \
   $RPM_BUILD_ROOT/usr/%{_lib}/xorg/modules/updates/drivers/
rmdir $RPM_BUILD_ROOT/usr/%{_lib}/xorg/modules/drivers
%endif
%if 0%{?mandriva_version} > 2006
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man4
mv $RPM_BUILD_ROOT/*.4 $RPM_BUILD_ROOT/%{_mandir}/man4
%endif
%else
make install DESTDIR=$RPM_BUILD_ROOT
make install.man DESTDIR=$RPM_BUILD_ROOT
%endif
%if 0%{?suse_version} > 1000
###
### generate SaX2/hwinfo data
###
mkdir -p $RPM_BUILD_ROOT/usr/share/sax/sysp/maps/update/ \
         $RPM_BUILD_ROOT/usr/share/sax/api/data/cdb/ \
         $RPM_BUILD_ROOT/var/lib/hardware/ids
> $RPM_BUILD_ROOT/usr/share/sax/sysp/maps/update/Identity.map.20.%name
> $RPM_BUILD_ROOT/usr/share/sax/api/data/cdb/Cards.%name
> $RPM_BUILD_ROOT/var/lib/hardware/ids/%name
NAME=VIA
SERVER=unichrome
PROFILE=
cat $RPM_SOURCE_DIR/pci_ids support | \
while read line; do
  VID=$(echo "$line"|cut -d "#" -f 1)
  DID=$(echo "$line"|cut -d "#" -f 2)
  DEVICE=$(echo "$line"|cut -d "#" -f 3)
  cat >> $RPM_BUILD_ROOT/usr/share/sax/sysp/maps/update/Identity.map.20.%name << EOF
NAME=${NAME}&DEVICE=${DEVICE}&VID=${VID}&DID=${DID}&SERVER=${SERVER}&EXT=&OPT=&RAW=&PROFILE=${PROFILE}&SCRIPT3D=&PACKAGE3D=&FLAG=DEFAULT
EOF
  cat >> $RPM_BUILD_ROOT/usr/share/sax/api/data/cdb/Cards.%name << EOF
${NAME}:${DEVICE} {
 Driver    = ${SERVER}
}
EOF
  cat >> $RPM_BUILD_ROOT/var/lib/hardware/ids/%name << EOF
 vendor.id              pci ${VID}
&device.id              pci ${DID}
+device.name            ${DEVICE}
+driver.xfree           4|${SERVER}
EOF
  echo >> $RPM_BUILD_ROOT/var/lib/hardware/ids/%name
done
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%if 0%{?suse_version} > 1000
%dir /usr/share/sax
%dir /usr/share/sax/api
%dir /usr/share/sax/api/data
%dir /usr/share/sax/api/data/cdb
%dir /usr/share/sax/sysp
%dir /usr/share/sax/sysp/maps
%dir /usr/share/sax/sysp/maps/update
%dir /var/lib/hardware
%dir /var/lib/hardware/ids
%endif
%if 0%{?suse_version} > 1010 || 0%{?fedora_version} >= 6 || 0%{?mandriva_version} > 2006
%if 0%{?suse_version} > 1020 && 0%{?suse_version} < 1100
%dir %{_libdir}/xorg/modules/updates/drivers
%{_libdir}/xorg/modules/updates/drivers/*_drv.la
%{_libdir}/xorg/modules/updates/drivers/*_drv.so
%else
%dir %{_libdir}/xorg/modules/drivers
%{_libdir}/xorg/modules/drivers/*_drv.la
%{_libdir}/xorg/modules/drivers/*_drv.so
%endif
%{_mandir}/man4/*
%else
%dir /usr/X11R6/%{_lib}/modules
%dir /usr/X11R6/%{_lib}/modules/drivers
/usr/X11R6/%{_lib}/modules/drivers/*_drv.*
/usr/X11R6/man/man4/*
%endif
%{_libdir}/libXvMCunichrome.la
%{_libdir}/libXvMCunichrome.so
%{_libdir}/libXvMCunichrome.so.1
%{_libdir}/libXvMCunichrome.so.1.0.0
%if 0%{?suse_version} > 1000
/usr/share/sax/api/data/cdb/Cards.%{name}
/usr/share/sax/sysp/maps/update/Identity.map.20.%{name}
/var/lib/hardware/ids/%{name}
%endif
%if 0%{?suse_version} > 1000

%post
if ls var/lib/hardware/ids/* &> /dev/null; then
  cat var/lib/hardware/ids/* > var/lib/hardware/hd.ids
else
  rm -f var/lib/hardware/hd.ids
fi
exit 0

%postun
if ls var/lib/hardware/ids/* &> /dev/null; then
  cat var/lib/hardware/ids/* > var/lib/hardware/hd.ids
else
  rm -f var/lib/hardware/hd.ids
fi
exit 0
%endif

%changelog
* Sat Oct  9 2010 sndirsch@novell.com
- libdrm-2.4.20.diff
  * fixed build against libdrm 2.4.20 (libdrm header files moved
    from /usr/include/drm to /usr/include/libdrm)
* Sun Nov 29 2009 sndirsch@suse.de
- update to git commit cd12cce (2009-11-17)
  * XvMC support
  * fixes in XvMC and Xv
  * README: Provide intro, add package building and XvMC section.
  * manual page: Update chipsets and add XvMC section and option.
  * support for Belinea C.Book 150x (VT3371)
* Sun Nov 29 2009 sndirsch@suse.de
- disabled via/openchrome wrapper (also obsoletes reverse applied
  commit-18bcba7.diff)
* Wed Nov 18 2009 sndirsch@suse.de
- This xorg-x11-driver-video-unichrome package update is part of the
  X stack update for SLE11-SP1 (FATE #307236)
* Fri Oct 30 2009 sndirsch@suse.de
- update to git commit 4ce10d4 (2009-10-20)
  * adds chip support for VX800 (VT1122)
  * removes chip support for non-existing CN750/CN800 (VT3225)
  * support for MSI K9VGM-V (VT3108)
  * support for MSI P4M890M (VT3343)
  * support for Foxconn P4M9007MB (VT3371)
  * support for Asus M2V-MX SE (VT3230)
  * support for Quanta IL1 (VT1122)
  * support for MSI Fuzzy CN700 (VT3344)
- obsoletes sles10.diff
- commit-18bcba7.diff (reverse applied)
  * revert openchrome wrapper
- removed no longer existing "--enable-experimental" configure
  option
* Sun Oct 18 2009 sndirsch@suse.de
- specfile: commented out Supplements for chips with experimental
  support (related to bnc #548015)
* Sun Oct 18 2009 sndirsch@suse.de
- sles10.diff: fixes build on SLES10
* Sat Aug 29 2009 sndirsch@suse.de
- update to git commit 5d542c6 (2009-08-29)
  * experimental support for
  - VT3118: PM800, CN400, PM880, whatever.
  - VT3344: P4M800Pro, CN700, VN800
  - VT3157: CX700
  - VT3230: K8M890
  - VT3343: P4M890
  - VT3371: P4M900
  * FB Mapping: fix mapping of AMD k8 direct FB under libpciaccess
    (bnc #515352)
  * various other fixes and improvements
* Wed Mar  4 2009 sndirsch@suse.de
- added appropriate Supplements to specfile (bnc #481569)
* Sat Jan 24 2009 sndirsch@suse.de
- renamed Identity.map.* to Identity.map.20.*, so it's possible
  to provide an Identity.map.<X>.* (X < 20) together with an
  alternative driver, which then will be preferred by SaX2
* Mon Jan  5 2009 sndirsch@suse.de
- update to git commit 49f401b (2008-12-29)
  * Panel: Enhance CRTC2  logic for retrieving panel resolution
    from VT.
  * Accel: Stop syncing when no acceleration is enabled.
  * Probe: unify code for supported chipsets check.
  * ID: VT3371: HP Mininote (2133).
  * I2C: Be more verbose when scanning busses.
* Fri Dec 19 2008 sndirsch@suse.de
- update to git commit 1464eb9 (2008-12-17)
  * Memory Typing: Teach the driver about DDR2.
  * Tabs cleanup: clean up via_host.c and VIAProbe.
  * Host: Add P4M900 support.
  * Host: Add CX700 support.
  * DRI: Support AGPv3 modes correctly.
  * Host: Allow more memory bandwidth when using DDR2 533.
  * Host: Make FBBase retrieval more resilient.
  * Change driver name from "via" to "unichrome".
  * Wrapper: provide autoconf logic.
  * Host: Add host support for CN400, CN700, P4M890, K8M890 and VX800.
  * CLE266: Bus DFP: only null CR88.6 when using TMDS.
  * fix make dist: man/wrapper.man and src/via_panel.h don't exist.
  * fix make dist: EXTRA_DIST git_version.sh
  * MapFB: move MTRR hack to a place where we _do_ know the FrameBufferBase.
  * Host FBBaseGet: Fix FrameBufferBase on 64bit.
- obsoletes xf86-video-unichrome.diff
* Mon Aug 18 2008 ro@suse.de
- change prereq to coreutils
* Fri Aug  8 2008 sndirsch@suse.de
- fixed Prerequires (bnc #415674)
* Fri Aug  8 2008 sndirsch@suse.de
- update to git commit fa90a8f (2008-08-07)
  * Port driver to work on top of libpciaccess.
* Thu Jul 31 2008 sndirsch@suse.de
- added missing Prerequires (bnc #413561)
* Tue Apr 15 2008 sndirsch@suse.de
- update to git (20080411)
  * manpage: warn about the danger of option DisableIrq
  * Silence enum comma warnings by moving some headers out of the
    main header.
  * Sanitise the options to disable the use of the commandbuffer.
  * CloseScreen: Move 3d engine reset to before VQDisable.
* Fri Apr 11 2008 sndirsch@suse.de
- SUBVENDOR/SUBDEVICE in Identity.map must not be empty
  (bnc #372874)
* Fri Mar 21 2008 sndirsch@suse.de
- update to git (20080319)
  * VT7205: properly disable TV CLK Input on FX43G.
* Sat Feb  2 2008 sndirsch@suse.de
- fixed generation of /var/lib/hardware/hd.ids in %%post(un)
* Tue Dec 18 2007 sndirsch@suse.de
- generate generate SaX2/hwinfo data
* Mon Dec 17 2007 sndirsch@suse.de
- update to git 6660bb5
  * Test commit to see whether the git update script is still good.
  * Simultaneous: properly disable simultaneous when already set in
    console.
* Thu Nov  1 2007 sndirsch@suse.de
- moved module to update directory for openSUSE 10.3
* Thu Nov  1 2007 sndirsch@suse.de
- fixed ModuleData symbol name (Bug #227741, comment #26)
* Thu Oct 18 2007 sndirsch@suse.de
- make sure to install this package during update
* Thu Aug 30 2007 sndirsch@suse.de
- created package
